searchNodes=[{"doc":"A Webmention implementation for Elixir Goals [x] Send WebMentions [ ] Receive Webmentions (in progress) [x] Configurable storage, defaulting to ets [ ] Easy local development and management of WebMentions including: [ ] Accept [ ] Decline [ ] Verify [ ] Block Usage All aspects of the library can be used piecemeal or as a supervised system. Sending When using piecemeal, the functions worth exploring are in Libmention.Outgoing : Libmention.Outgoing.parse/1 is used to parse an html document for all unique links. The idea here is to pass in the body of your post/note/comment and determine which urls may need to have a webmention sent. Libmention.Outgoing.discover/2 takes a link, sends a discovery and determines if webmention is supported at that specific link Libmention.Outgoing.send/4 sends a webmention When using as a supervised system, add the Libmention.Supervisor to your supervision tree and configure it for sending. config = [ outgoing : [ storage : Libmention.EtsStorage ] ] children = [ ... , { Libmention.Supervisor , config } ] See Libmention.Supervisor for a full list of options Then to send webmentions for a page or content, Libmention.Supervisor . send ( url , html ) When the process is done, Receiving","ref":"Libmention.html","title":"Libmention","type":"module"},{"doc":"See Sending Webmentions for the full spec. Functions for finding links in an html document, discovering webmention support, and sending webmentions from a source_url to a target_url .","ref":"Libmention.Outgoing.html","title":"Libmention.Outgoing","type":"module"},{"doc":"Fetchs the URL and checks for an HTTP Link header with a rel value of webmention. Initially make an HTTP HEAD request to check for the Link header before making a GET request. When making a GET request, if the content type of the document is HTML, looks for an HTML &lt;link&gt; and &lt;a&gt; element with a rel value of webmention. If more than one of these is present, the first HTTP Link header takes precedence, followed by the first &lt;link&gt; or &lt;a&gt; element in document order. Returns the Webmention link found at the target url. Options user_agent - defaults to libmention-Webmention-Discovery","ref":"Libmention.Outgoing.html#discover/2","title":"Libmention.Outgoing.discover/2","type":"function"},{"doc":"Find available links in an html document. This is typically used to find links in your post or other html document that may need Webmentions sent.","ref":"Libmention.Outgoing.html#parse/1","title":"Libmention.Outgoing.parse/1","type":"function"},{"doc":"Sends a webmention to endpoint . source_url is the URL of the html page containing a link target_url is the URL of the page being linked to If the endpoint supports sending back a location for monitoring the queued request, an {:ok, url} will be returned, otherwise just an :ok will be returned. Options user_agent - defaults to libmention-Webmention-Discovery proxy - useful when Libmention.Outgoing.Proxy is configured","ref":"Libmention.Outgoing.html#send/4","title":"Libmention.Outgoing.send/4","type":"function"},{"doc":"A proxy is available for local development purposes. When the proxy is enabled, all outgoing http requests are routed to it. This provides a way to test your outgoing webmentions locally since they will always fail when running on a localhost. The reason they will fail is because the server receiving the webmention is, according to the spec, required to query the sender (in this case localhost) and validate the url that was sent. In the case of local development, this will fail and you won't get a good idea if you are sending the correct payload. The proxy also makes available a small web-based dashboard where you can inspect the webmentions you sent including their payload. By default, the proxy exposes a web interface at http://localhost:8082/sent but the port is configurable via the Libmention.Supervisor Outgoing options.","ref":"Libmention.Outgoing.Proxy.html","title":"Libmention.Outgoing.Proxy","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Libmention.Outgoing.Proxy.html#child_spec/1","title":"Libmention.Outgoing.Proxy.child_spec/1","type":"function"},{"doc":"The behaviour for required for storing a webmention. By default ets is used, but implementing this behaviour and setting your configuration value to that implementation, you can use any storage backend you want.","ref":"Libmention.StorageApi.html","title":"Libmention.StorageApi","type":"behaviour"},{"doc":"","ref":"Libmention.StorageApi.html#c:exists?/1","title":"Libmention.StorageApi.exists?/1","type":"callback"},{"doc":"","ref":"Libmention.StorageApi.html#c:get/1","title":"Libmention.StorageApi.get/1","type":"callback"},{"doc":"This is called after a webmention is sent. Saving the webmention result in storage means that we can make better decisions about if we want to send another webmention or not.","ref":"Libmention.StorageApi.html#c:save/1","title":"Libmention.StorageApi.save/1","type":"callback"},{"doc":"This is called when the content of a webmention (sha) changes and we've already and we sent another one.","ref":"Libmention.StorageApi.html#c:update/1","title":"Libmention.StorageApi.update/1","type":"callback"},{"doc":"The shape of the webmention passed to the save/update/exists? calls","ref":"Libmention.StorageApi.html#t:entity/0","title":"Libmention.StorageApi.entity/0","type":"type"},{"doc":"Responsible for managing send and receive jobs. Put this in your supervision tree to start the processes of sending and/or receiving webmentions. opts = [ outgoing : [ ] , incoming : [ ] ] children = [ ... , { Libmention.Supervisor , opts } ] Options A keyword list of options is accepted for configuring one or both of incoming webmentions (See &quot;Incoming Opts&quot; section) outgoing webmentions (See &quot;Outgoing Opts&quot; section) Incoming opts Outgoing opts If you desire to send webmentions from your site, an outgoing key should be configured which takes it's own keyword list of options. outgoing : [ user_agent : &quot;&quot; , storage : Libmention.EtsStorage , proxy : [ port : 8082 ] ] Options include: user_agent - String - Customize the HTTP User Agent used when fetching the target URL. Defaults to &quot;libmention-Webmention-Discovery&quot; storage - Module - The storage behaviour module to use when sending webmentions. Defaults to Libmention.EtsStorage . See Libmention.StorageApi for more options. proxy - Keyword List - This is useful for local development only. If enabled, it starts a Plug application on the requested port proxy: [port: 8082] that all sent webmentions go to and shows a dashboard with their payloads. See Libmention.Outgoing.Proxy for more information.","ref":"Libmention.Supervisor.html","title":"Libmention.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Libmention.Supervisor.html#child_spec/1","title":"Libmention.Supervisor.child_spec/1","type":"function"},{"doc":"Starts a process that parses, validates and sends webmentions.","ref":"Libmention.Supervisor.html#send/2","title":"Libmention.Supervisor.send/2","type":"function"},{"doc":"","ref":"Libmention.Supervisor.html#start_link/1","title":"Libmention.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Libmention.Outgoing.Error.html","title":"Libmention.Outgoing.Error","type":"exception"},{"doc":"A Webmention implementation for Elixir","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"[x] Send WebMentions [ ] Receive Webmentions (in progress) [x] Configurable storage, defaulting to ets [ ] Easy local development and management of WebMentions including: [ ] Accept [ ] Decline [ ] Verify [ ] Block","ref":"readme.html#goals","title":"Readme - Goals","type":"extras"},{"doc":"All aspects of the library can be used piecemeal or as a supervised system. Sending When using piecemeal, the functions worth exploring are in Libmention.Outgoing : Libmention.Outgoing.parse/1 is used to parse an html document for all unique links. The idea here is to pass in the body of your post/note/comment and determine which urls may need to have a webmention sent. Libmention.Outgoing.discover/2 takes a link, sends a discovery and determines if webmention is supported at that specific link Libmention.Outgoing.send/4 sends a webmention When using as a supervised system, add the Libmention.Supervisor to your supervision tree and configure it for sending. config = [ outgoing : [ storage : Libmention.EtsStorage ] ] children = [ ... , { Libmention.Supervisor , config } ] See Libmention.Supervisor for a full list of options Then to send webmentions for a page or content, Libmention.Supervisor . send ( url , html ) When the process is done, Receiving","ref":"readme.html#usage","title":"Readme - Usage","type":"extras"},{"doc":"Add libmention to your list of dependencies in mix.exs : def deps do [ { :libmention , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixed * Invalid return from outgoing worker","ref":"changelog.html#0-1-2","title":"Changelog - [0.1.2]","type":"extras"},{"doc":"Added * Proxy for local development when sending webmentions","ref":"changelog.html#0-1-1","title":"Changelog - [0.1.1]","type":"extras"},{"doc":"Added * The ability to send webmentions * Configurable storage , defaulting to ets","ref":"changelog.html#0-1-0","title":"Changelog - [0.1.0]","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"LICENSE.html","title":"License","type":"extras"}]